from typing import List, Optional, Tuple
from axelrod._strategy_utils import detect_cycle
from axelrod.action import Action
from axelrod.player import Player
IlIlIlIl, lllllllIllIIllll = Action.C, Action.D
def lIlIIIIIIlIIllIIl(llllllllllllIIII: List[Action]) -> bool:
    for IIlIIllllIll in range(len(llllllllllllIIII) - 1):
        if llllllllllllIIII[IIlIIllllIll] == llllllllllllIIII[IIlIIllllIll + 1]:
            return False
    return True
class llIIIlIIIIII(Player):
    IIIllIlIIl = "strategy"
    IIIIIlIIllII = {
        "memory_depth": float("inf"),  
        "stochastic": False,
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def IIlIlllllIllllIllIIl(lIIIIIIlIllll, lIllllIlI: Player) -> Action:
        if (
            len(lIIIIIIlIllll.llllllllllllIIII) >= 4
            and len(lIllllIlI.llllllllllllIIII) == lIllllIlI.defections
        ):
            return lllllllIllIIllll
        return IlIlIlIl